#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

//#define PUERTO 8000

int leer_linea(int sfd, char *buf, int nbytes){
 int n=0, nb;
 char b;

 for(n=1;n<nbytes;n++) {
    nb=read(sfd,&b,1);
    if(b=='\n') break;
    else *buf++=b;
 }
 *buf=0;
 return n;
}

int leer_registro(char maquina[50],char IP[15],char PUERTO[10]){
 FILE *DNS;
 char *archivo="dominio.txt";
 char ALIAS[50];
 int flag=0;

 if((DNS=fopen(archivo,"rt"))==NULL){
   printf("Error al abrir el archivo DNS");
   return -1;
 }

 while((flag!=1)&&(!feof(DNS))){
   fscanf(DNS,"%s %s %s",ALIAS,IP,PUERTO);
   if(strcmp(ALIAS,maquina)==0)
     flag=1;
 }
 fclose(DNS);
 return flag;
}

int asignar_direccion_puerto(int sfd){
 int n, nbytes;
 char maquina[50];
 char ALIAS[50];
 char IP[15];
 char PUERTO[10];
 char mensaje[30];
 int flag;

 if((n=leer_linea(sfd,maquina,256))==-1){
   printf("Error en la lectura de la pagina solicitada");
   return -2;
 }
 
 printf("BUSCANDO PETICION DE %s\n",maquina);

 if((flag=leer_registro(maquina,IP,PUERTO))!=1){
   printf("Error: maquina no encontrada");
   return -1;
 }

 strcpy(mensaje,IP);
 strcat(mensaje," ");
 strcat(mensaje,PUERTO);
 strcat(mensaje,"\n");
 
 printf("LAS CARACTERISTICAS SON: %s\n", mensaje);

 nbytes=strlen(mensaje);
 if((n=write(sfd,mensaje,nbytes)) == -1){
   printf("Error en la escritura del nombre del servidor de pagina");
   return -3;
 }
 return 0;
}

int main(int argc, char *argv[]) {
 int sfd, nsfd, pid;
 struct sockaddr_in d_servidor_nombres, d_cliente;
 int lon_d_cliente;
 char nombre_host[256];
 struct hostent *host_servidor;
 int PUERTO=8000;

 // OBTIENE CARACTERISTICAS DE LA MAQUINA
 printf("OBTENIENDO CARACTERISTICAS DE LA MAQUINA...\n");
 if(gethostname(nombre_host, sizeof(nombre_host))==-1) {
   printf("Error en la lectura del archivo /etc/host");
   exit(0);
 }

 if((host_servidor=gethostbyname(nombre_host))==NULL){
   printf("Error en la asignacion del entorno del servidor");
   exit(0);
 }

 // SE ESTABLECE EL SOCKET()
 printf("ESTABLECIENDO CANAL...\n");

 if((sfd=socket(AF_INET,SOCK_STREAM,0))==-1){
   printf("Error en la definicion del socket");
   exit(0);
 }

 printf("Servidor de Nombres de Paginas Web %s\n",host_servidor->h_name);

 d_servidor_nombres.sin_family = AF_INET;
 d_servidor_nombres.sin_addr.s_addr = *(long *)host_servidor->h_addr;
 d_servidor_nombres.sin_port = htons(PUERTO);

 if (bind(sfd, &d_servidor_nombres, sizeof(d_servidor_nombres))==-1){
	printf("Error en la publicacion del socket");
	exit(0);
 }

 listen(sfd,25);

 for(;;){
   lon_d_cliente=sizeof(d_cliente);
   printf("+++ ESPERANDO PETICION ...\n");
   if((nsfd=accept(sfd,&d_cliente,&lon_d_cliente)) == -1){
     printf("Error en la aceptacion de peticiones por parte de los clientes");
     exit(0);
   }
   printf(">>> DETECTADO PETICION...\n");
   pid=fork();
   if(pid==-1){
     printf("Error en la creacion del proceso hijo");
     exit(0);
   }
   else 
     if(pid==0){
       close(sfd);
       asignar_direccion_puerto(nsfd);
       close(nsfd);
       exit(0);
     }
   close(nsfd);
 }
 return 0;
}